"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs = __importStar(require("yargs"));
const init_1 = __importDefault(require("./commands/init"));
const sandbox_1 = __importDefault(require("./commands/sandbox"));
const compile_1 = __importDefault(require("./commands/compile"));
const flatten_1 = __importDefault(require("./commands/flatten"));
const test_1 = __importDefault(require("./commands/test"));
const env_1 = require("./lib/env");
const { argv } = yargs
    .usage('Usage: $0 --help')
    .command('compile', 'Compiles solidity contracts', (yargs) => yargs
    .usage('Usage: $0 --match *.sol --build ./build')
    .option('match', {
    array: true,
    description: 'Matching pattern',
})
    .option('evmVersion', {
    string: true,
    description: 'EVM version which will be used',
})
    .option('build', {
    string: true,
    description: 'Build folder path',
})
    .option('severities', {
    array: true,
    description: 'Toggle error and warnings visibility',
})
    .option('optimization', {
    number: true,
    description: 'Code optimization level',
})
    .option('clean', {
    boolean: true,
    description: 'Clean output',
}), compile_1.default)
    .command('flatten', 'Flattens solidity contracts', (yargs) => yargs
    .usage('Usage: $0 --match *.sol --build ./build')
    .option('match', {
    array: true,
    description: 'Matching pattern',
})
    .option('build', {
    string: true,
    description: 'Build folder path',
})
    .option('severities', {
    array: true,
    description: 'Toggle error and warnings visibility',
}), flatten_1.default)
    .command('init', 'Initializes project directory.', (yargs) => yargs
    .option('name', {
    string: true,
    description: 'Project name',
})
    .option('description', {
    string: true,
    description: 'Project description',
}), init_1.default)
    .command('sandbox', 'Starts Ethereum sandbox server.', (yargs) => yargs
    .option('port', {
    number: true,
    description: 'Server port number',
}), sandbox_1.default)
    .command('test', 'Runs tests', (yargs) => yargs
    .option('match', {
    array: true,
    description: 'Match pattern',
})
    .option('require', {
    array: true,
    description: 'Require dependencies',
})
    .option('server', {
    boolean: true,
    description: 'Start sandbox server',
})
    .option('port', {
    number: true,
    description: 'Server port number',
})
    .option('blockTime', {
    number: true,
    description: 'Seconds for automatic mining',
}), test_1.default)
    .epilog('Copyright © Xpepermint 2018.')
    .help()
    .version();
env_1.getConfig(argv).require.forEach((v) => require(v));
//# sourceMappingURL=index.js.map